﻿Public Class EnhancedCarPaymentCalculatorForm

   ' handles Calculate Button's Click event
   Private Sub calculateButton_Click(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles calculateButton.Click

      Dim years As Integer = 2 ' repetition counter
      Dim months As Integer = 0 ' payment period
      Dim price As Integer = 0 ' car price
      Dim downPayment As Integer = 0 ' down payment
      Dim interest As Double = 0 ' interest rate
      Dim monthlyPayment As Decimal = 0 ' monthly payment
      Dim loanAmount As Integer = 0 ' cost after down payment
      Dim monthlyInterest As Double = 0 ' monthly interest rate

      ' remove text displayed in ListBox
      paymentsListBox.Items.Clear()

      ' add header to ListBox
      paymentsListBox.Items.Add("Months" & ControlChars.Tab & _
         ControlChars.Tab & "Monthly Payments")

      ' retrieve user input and assign values
      ' to their respective variables
      downPayment = Convert.ToInt32(Val(downPaymentTextBox.Text))
      price = Convert.ToInt32(Val(priceTextBox.Text))
      interest = Convert.ToDouble(Val(interestTextBox.Text) / 100)

      ' determine amount borrowed and monthly interest rate
      loanAmount = price - downPayment
      monthlyInterest = interest / 12

      ' calculate payments for two, three, four and five year loans
      Do While years <= 5
         ' calculate payment period
         months = 12 * years

         ' calculate monthly payment using Pmt
         monthlyPayment = Convert.ToDecimal( _
            Pmt(monthlyInterest, months, -loanAmount))

         ' display payment value
         paymentsListBox.Items.Add(months & ControlChars.Tab & _
            ControlChars.Tab & String.Format("{0:C}", _
            monthlyPayment))

         years += 1 ' increment counter
      Loop
   End Sub ' calculateButton_Click
End Class ' EnhancedCarPaymentCalculatorForm

' **************************************************************************
' * (C) Copyright 1992-2009 by Deitel & Associates, Inc. and               *
' * Pearson Education, Inc. All Rights Reserved.                           *
' *                                                                        *
' * DISCLAIMER: The authors and publisher of this book have used their     *
' * best efforts in preparing the book. These efforts include the          *
' * development, research, and testing of the theories and programs        *
' * to determine their effectiveness. The authors and publisher make       *
' * no warranty of any kind, expressed or implied, with regard to these    *
' * programs or to the documentation contained in these books. The authors *
' * and publisher shall not be liable in any event for incidental or       *
' * consequential damages in connection with, or arising out of, the       *
' * furnishing, performance, or use of these programs.                     *
' **************************************************************************